AutoCAD Inventor :: How To Close A Text File From Within An ILogic
Nov 3, 2012
I have an iLogic that runs to create parts and assemblies. These parts and sub-assemblies are for a range of library components which are either part(s) or assemblies or and assemblies composed of parts) and sub-assemblies as well. This iLogic is mostly done despite I have limited knowledge in this area. At the beginning it opens a text file (.txt) by the command line:
ThisDoc.Launch("L:\_Nov 02Info and Input GuideLines.txt")that offers guidelines and instructions.
I would like to how can I close (exit) this text file at a point within or end of the current iLogic because, it opens a several files of the same every time I run the iLogic otherwise.
How to close an application (*.ipt & *.iam) by ilogic code?I tried to use...ThisDoc.Document.close (True) to close it.Indeed, it can close the application, but there is an error occurred as following:
Catastrophic failure (Exception from HRESULT: 0x8000FFFF (E_UNEXPECTED))
how to avoid this error or any other way to close (or exit) the application?
I am trying to enter some material ordering info into an external spreadsheet, and have that info reflected in a text box within an idw drawing file.
My method is as follows:
Obtain a numerical value (250) from an external Excel spreadsheet (sample.xlsx).Assign this value to a parameter (abc) in an idw file (Materials Ordering.idw).Insert parameter abc I made into a text box within the same idw file.
I made a set_parameters rule, and the ilogic text of the above example is as follows:
'Open File and Scan line - Part = Impeller Casing Flange i = GoExcel.FindRow("sample.xlsx", "Sheet1", "Part", "<=", "Impeller Casing Flange") 'abc = Material Width abc = GoExcel.CurrentRowValue("Material Width")
I had no problems with the first two steps, after checking the parameters I could see that parameter abc is being updated successfully.
However, I am having trouble with the third step. In the format text dialog box, I can see a drop box for components, but I can't find a reference to the idw file in there.
My question is, am I going the wrong way about this? Should I have assigned the parameters to a component instead of the idw file?
I have some code (below) that will open my embedded excel spread sheet and it works great. Now I need the code to save and close the excel file after it’s been open.The embedded excel spreadsheet pushes some stuff the model and does a couple other thing. So all I really need is for the excel file to open, save, and close when the rule is run.Imports Inventor.
OLEDocumentTypeEnumExcelApp = CreateObject("Excel.Application")Dim ExcelFile As ReferencedOLEFileDescriptorExcelFile =hisDoc.Document.ReferencedOLEFileDescriptors.Item(1)ExcelFile.Activate(kEditOpenOLEVerb, ExcelApp)
We have an idw package we use for Quality control. This idw has more than one sheet. Each sheet has a part placed on the sheet with dims.( DWF attached). Next we open DA inside of the file and run a report. (exported txt attached). I am trying to use ilogic the make the same report with a iLogic browser button pick. I have 2 codes (code examples on attached jpg) that i need to make into 1, or whatever works.
1st code Dim oDoc As DrawingDocumentoDoc = ThisApplication.ActiveDocument Dim oSubDoc As Inventor.Document Dim oPropSets As PropertySets Dim oPropSet As PropertySetDim oPartNumiProp As Inventor.Property For Each oSubDoc In oDoc.AllReferencedDocumentsIf oSubDoc.documenttype. [code]....
2nd code fileheader = "QAF Parts for Planning "fileheader1 = ThisDoc.PathAndFileName(True) 'first line header of txt filedescription = "Components to use for Nesting" 'use this variable in the body of the txtdelimiter = "," 'character to separate the names and values on each lineoWrite = System.IO. File. Create Text (ThisDoc.PathAndFileName(False) & ".txt")oWrite.WriteLine(fileheader) 'include the fileheader on the first. [code]....
I am using Inventor 2012 and C#. I would like that, when I close my Form, Inventor and all files that are open will be closed with displaying the message about saving the files .Some of my opened file are stored in Lists.
This code das not work Inventor still asking me about saving the files.
private void Form1_FormClosed(object sender, FormClosedEventArgs e) { if (InventorOpen._started) { oDrawDoc.Close(false); foreach (Inventor.AssemblyDocument openAssemDocument in openAssemDocumentsList) { openAssemDocument.Activate();
I had Inventor 2013 and it worked well for a long time, I didn't use it for a while, then yesterday I tried to use it again and it wouldn't work. It starts up fine, and gets to the menu where you can choose from recent files, new files, tutorials, etc. After I select anything to open, whether its a new or old file, the program will load open the file then immediately stop working. No error message is displayed besides Windows telling me "this program has stopped working". I updated to 2014 yesterday, and the exact same problem persists.
I'm trying to finally utilize iLogic and all of its functionality (after using the basic features of inventor for the past 3 or so years) and I was wondering if there was a way to use iLogic (or some other feature for inventor) to resize text in a title block field of an IDW based on the length of the text entered (i.e. if the part's name was "Cam Retainer" the text height would be .12, but if its part name was "Spacer Cam Retainer Bushing" the text height would shrink down to .085 or something) so that it would still fit nicely into the text block?
I'm linking an excel file to an .ipt file with iLogic code determining if the Material type is a certian value it will find the correct material thickness. These file work great when working on them thru Vault but when I "Save As Template" and create this file where our other template files are located (not Vault) this fuction does not work. I have realized that I had to place the a copy of the excel file in the same file folder as the template ipt, but even this does not fix the issue.
I recieve this error:
Error in rule: Material, in document: Part6
'MWW Materials (Inventor).xlsx' could not be found. Check the spelling of the file name, and verify that the file location is correct.
If you are trying to open the file from your list of most recently used files, make sure that the file has not been renamed, moved, or deleted.
It seems completly countintutive that just saving the file as a template file would cause this not to work when all files that are required are located in the same file folder. Maybe I need a reference to the excel document within the iLogic code.
I'm trying to use iLogic Design Copy to copy an assembly and all its associated parts to another directory. The assembly contains content center parts. Inventor warns me that the destination file of one of the CC parts (and 18 others) will be overwritten. When I go ahead and copy anyway, the copying process stops at that specific CC part. The Design Copy Progress dialog box states there is an error copying that CC part. When I close the Design Copy Progress dialog box, Inventor crashes.
The error copying the CC part: I'm allowed to use content center parts in iLogic Design Copied stuff, right? I searched some related topics and I'm under the impression that Inventor keeps the CC parts in its own directory and shouldn't be trying to overwrite them.
Im linking a prompted entry in a sketch symbol to a selection from the user in an array. The code works perfectly.
The array displays the number of sheets there are in the document, the user selects the correct one & the sheet number is displayed in the prompted entry. I need to add "SHT" before the number though in the code but I cant get it to work.
I dont want to add a text line into the symbol saying "sht"
Dim oApp As Application: oApp = ThisApplication Dim oDoc As DrawingDocument: oDoc = oApp.ActiveDocument Dim oSheet As Sheet: oSheet = oDoc.ActiveSheet
'This uses a sketch symbol with the name "'View On' View Label" Dim oSymDef As SketchedSymbolDefinition: oSymDef = oDoc.SketchedSymbolDefinitions.Item("'View On' View Label")
'This is the selected view Dim oView As DrawingView: oView = ThisApplication.CommandManager.Pick(SelectionFilterEnum.kDrawingViewFilter,"Select View To Place Symbol:")
'This takes the label items of the selected view 'And adds it To an array that will link To the prompted entry Dim sPromptStrings(2) As String sPromptStrings(0) = oView.Name sPromptStrings(1) = oView.ScaleString
oDoc = ThisApplication.ActiveDocument
Dim sSheet As Sheet
'create sheet number list Dim oSheetList As New ArrayList i = 0 s = "-" For Each sSheet In oDoc.Sheets i = i +1 oSheetList.add(i) Next oSheetList.add(s)
'get user input mySheet = (InputListBox("View taken form sheet number.", oSheetList, oSheetList(0), "Sheet Number Ref.", "Sheet Numbers"))
sPromptStrings(2) = mySheet
'This is the position for the sketched symbol under the selected view' Dim oPosition As Point2d: oPosition = oView.Center oPosition.y = oPosition.y - (oView.Height / 2 + 2.5)
'This inserts the sketched symbol and fills in the prompted entry. Dim oSymbol As SketchedSymbol: oSymbol = oSheet.SketchedSymbols.Add(oSymDef, oPosition, , ,sPromptStrings)
We are implementing the vault and do not want to have to rename each file with design copy.
Any way where the filename of a part will change according to either assembly pararmenters or iProperties?
Another question I had would be involving a rule that would rename each ipt within an assembly by giving at a suffix/prefix once the assembly is completed.
Is there a way I can open an idw file using ilogic? I would like to put the rule into a form, so that I can click a button in the form to open the idw for my assembly.
Inventor 2014 HP Pavilion dv6t-6b00 Intel Core i7 2670QM AMD Radeon HD 6490M 8gb RAM Windows 7 64 bit 3Dconnexion SpaceExplorer
I amrying to create embedding of a text entered through dialog box. The sketch regenerates fine but the Emboss doesn't. Cannot figure it out, tried a lot of different approaches...the text has to be configured this way - need to control it's height.
How to turn on/off text on the drawing? I`m working on the drawing template and would like to have a form that will allow engineer by checking check boxes to turn on/off certain text on the drawing.
I seem to have my task accomplished, but Inventor crahes on me after it is done.
Here is how my iLogic works.
' Deleting the suppressed parts from the assembly Dim compDef as AssemblyComponentDefinition compDef = ThisDoc.ComponentDefinition Dim compOcc as ComponentDefinition For Each compOcc in compDef [Code] ........
Now as soon as the last line is executed, Inventor crashes.
But when I go to the save file part (C:MyPath), both the parts and assembly files are saved and if I open it, they work just fine.
Is it possible in iLogic to select a file in a dialog box or a browser ?
I need to replace the 3d model on a drawing. I have to ask the user to select the new file to use. How can I select the file using a dialog box or a browser ? The best should be a combobox with the list of opened files, and a button to browse on the disk, like when you create a view.
My goal is to have a message box open as soon as an assembly file is opened so that other users will be warned/ notified of linked parameters. My assumption is that an iLogic rule would be the best way to handle this.
I can create the message box, but when I looked through the iLogic snippets I didn't find any way to trigger the box at opening the file.
I use Inventor 2010 with the iLogic Extension. My question is probably more VB.NEt-related than Inventor-related.
For my parts I usually have a main *.ipt that can receive input parameters and does some calculating with them. Then there are several 'slave' *.ipt that use the calculated parameters of the main.ipt. I would like to keep that structure. Using iLogic the slave.ipt's do some calculation, too, based on an external *.Vb-File. I load that file into the rules of the slave.ipts by using (for example) AddVbFile "External.Vb".
My question is if it is in any way possible to have it so that the name External.Vb can be dynamic? I tried using a new iLogic String parameter and storing the name of the external VB-File there so that I would have a Parameter Name = "External.Vb" and then use AddVbFile Name. But that sadly didn't work at all. My External.Vb is supposed to be unique for every copy of my assembly and having to write the correct name into the rule by hand is tedious.
I am trying to rewrite Curtis Waguespack's ilogic code to modify drawing view labels from this post http: [URL]...
The completed label should appear like this
<Description> - Mk <Part Number> Est Unit Mass = X kg (Scale 1:1)
At this point I have 2 problems
1. I want to add the physical mass to the second line and would prefer to use the calculated physcial property rather than the a custom iproperty. If editing the view label, it would the property access under physcial properties.
2. I want to rewrite the code so it is selective or per view - in otherwords, I only want it to modify a single view I select once the code is run. At this point I know I need to remove the For loop but I dont have a clue as to how to make it selective.
'start of ilogic codeDim oDoc As DrawingDocument: oDoc = ThisDoc.DocumentoModel = ThisDoc.ModelDocumentDim oSheets As SheetsDim oSheet As SheetDim oViews As DrawingViewsDim oView As DrawingViewoSheets = oDoc.SheetsFor Each oSheet In oSheetsoViews = oSheet.DrawingViews For Each oView In oViews oView.ShowLabel = True
I have a lot of pre existing sheet metal parts with my material listed as Steel, Mild.
I am using this code to automatcally fill out my iproperties but the material name is not exactly what I want it to say. iProperties.Value("Project", "Description")=iProperties.Material
I'd like it so that any time it sees Steel, Mild it replaces it with the text "A36"